--- old/bootadm/bootadm_hyper.c	2012-08-31 05:08:48.139702554 +0400
+++ new/bootadm/bootadm_hyper.c	2012-08-31 05:08:48.156871361 +0400
@@ -23,6 +23,10 @@
  * Copyright (c) 2009, 2010, Oracle and/or its affiliates. All rights reserved.
  */
 
+/*
+ * Copyright 2012 Daniil Lunev. All rights reserved.
+ */
+
 #include <stdio.h>
 #include <errno.h>
 #include <stdlib.h>
@@ -39,7 +43,7 @@
 #define	METAL_KERNEL_DIR 		"/platform/i86pc/kernel"
 
 #define	BOOTRC_FILE			"/boot/solaris/bootenv.rc"
-#define	ZFS_BOOTSTR			"$ZFS-BOOTFS"
+#define	ZFS_BOOTSTR			"$ZFS_BOOTFS"
 
 #define	BFLAG				"-B"
 #define	DEFAULT_SERIAL			"9600,8,n,1"
@@ -763,8 +767,10 @@
 	char *findroot = NULL;
 	char *bootfs = NULL;
 	char *kernel = NULL;
+	char *opts = NULL;
 	char *mod_kernel = NULL;
 	char *module = NULL;
+	char *tmp = NULL;
 
 	char *kern_path = NULL;
 	char *kern_bargs = NULL;
@@ -841,10 +847,12 @@
 		if (lp->flags == BAM_TITLE) {
 			title = strdupa(lp->arg);
 		} else if (lp->cmd != NULL) {
-			if (strcmp(lp->cmd, "findroot") == 0) {
+			if (strcmp(lp->cmd, "pool_label") == 0) {
 				findroot = strdupa(lp->arg);
-			} else if (strcmp(lp->cmd, "bootfs") == 0) {
+			} else if (strcmp(lp->cmd, "data_set") == 0) {
 				bootfs = strdupa(lp->arg);
+			} else if (strcmp(lp->cmd, "kernel_options") == 0) {
+				opts = strdupa(lp->arg);
 			} else if (strcmp(lp->cmd,
 			    menu_cmds[MODULE_DOLLAR_CMD]) == 0) {
 				module = strdupa(lp->arg);
@@ -866,6 +874,7 @@
 			break;
 	}
 
+	
 	/*
 	 * If findroot, module or kern_path are NULL, the boot entry is
 	 * malformed.
@@ -948,7 +957,10 @@
 	zfslen = (zfs_boot ? (WHITESPC(1) + strlen(ZFS_BOOT)) : 0);
 
 	mod_kernel = alloca(len + zfslen);
-	(void) snprintf(mod_kernel, len, "%s %s", kern_path, kern_path);
+	if (opts)
+		(void) snprintf(mod_kernel, len + strlen(opts) + 1, "%s %s %s", kern_path, kern_path, opts);
+	else
+		(void) snprintf(mod_kernel, len, "%s %s", kern_path, kern_path);
 
 	if (kp_allocated)
 		free(kern_path);
@@ -1062,9 +1074,9 @@
 		if (lp->flags == BAM_TITLE) {
 			title = strdupa(lp->arg);
 		} else if (lp->cmd != NULL) {
-			if (strcmp(lp->cmd, "findroot") == 0) {
+			if (strcmp(lp->cmd, "pool_label") == 0) {
 				findroot = strdupa(lp->arg);
-			} else if (strcmp(lp->cmd, "bootfs") == 0) {
+			} else if (strcmp(lp->cmd, "data_set") == 0) {
 				bootfs = strdupa(lp->arg);
 			} else if (strcmp(lp->cmd,
 			    menu_cmds[MODULE_DOLLAR_CMD]) == 0) {
